
import urllib
import xml.dom.minidom
import dateutil.parser
from dateutil.tz import *
import datetime, time

def XmlFromUrl(url):
	time.sleep(1) #Prevent runaway queries
	dom = xml.dom.minidom.parse(urllib.urlopen(url))
	#print dom.toxml()
	return dom

def GetChangesetIdsAndMinTime(xmldom):
	changesets = xmldom.getElementsByTagName("osm")[0].getElementsByTagName("changeset")
	outListChangesetIds = []
	outMinTime = None

	for changeset in changesets:
		#print changeset.toxml()
		attributes = changeset.attributes
		idNum = int(attributes["id"].value)
		outListChangesetIds.append(idNum)
		createdAt = dateutil.parser.parse(attributes["created_at"].value)
		closedAt = dateutil.parser.parse(attributes["closed_at"].value)
		if outMinTime == None or createdAt < outMinTime:
			outMinTime = createdAt
		print idNum, createdAt.isoformat()
	
		#print time.mktime(createdAt.timetuple())
		#print createdAt.isoformat()
	return outListChangesetIds, outMinTime



displayName = "TimSC"
xmldom = XmlFromUrl("http://www.openstreetmap.org/api/0.6/changesets?display_name="+displayName)

listChangesetIds, minTime = GetChangesetIdsAndMinTime(xmldom)

running = True
limit, count = None, 0
while running:
	print "minTime",minTime.isoformat()
	url = "http://www.openstreetmap.org/api/0.6/changesets?display_name="+displayName \
		+"&time="+datetime.date.fromtimestamp(0).isoformat()+","+minTime.isoformat()
	#print url
	xmldom = XmlFromUrl(url)

	tempIds, minTime = GetChangesetIdsAndMinTime(xmldom)

	if len(tempIds) == 0:
		running = 0
	listChangesetIds.extend(tempIds)
	count = count + 1
	if count >= limit and limit is not None:
		running = 0

fi = open("changesets.txt","wt")
for idNum in listChangesetIds:
	fi.write(str(idNum)+"\n")

print "All done!"

